searchNodes=[{"doc":"This module parse and validate arguments.","ref":"DoIt.Argument.html","title":"DoIt.Argument","type":"module"},{"doc":"","ref":"DoIt.Argument.html#parse_input/2","title":"DoIt.Argument.parse_input/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition/1","title":"DoIt.Argument.validate_definition/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_allowed_values/1","title":"DoIt.Argument.validate_definition_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_description/1","title":"DoIt.Argument.validate_definition_description/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_name/1","title":"DoIt.Argument.validate_definition_name/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_definition_type/1","title":"DoIt.Argument.validate_definition_type/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input/2","title":"DoIt.Argument.validate_input/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_allowed_values/1","title":"DoIt.Argument.validate_input_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_allowed_values/2","title":"DoIt.Argument.validate_input_allowed_values/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_value/1","title":"DoIt.Argument.validate_input_value/1","type":"function"},{"doc":"","ref":"DoIt.Argument.html#validate_input_value/2","title":"DoIt.Argument.validate_input_value/2","type":"function"},{"doc":"","ref":"DoIt.Argument.html#t:t/0","title":"DoIt.Argument.t/0","type":"type"},{"doc":"DoIt helper functions.","ref":"DoIt.Helper.html","title":"DoIt.Helper","type":"module"},{"doc":"Validates if all allowed values are of the same type. Examples iex&gt; DoIt.Helper . validate_list_type ( [ 0 , 1 , 2 , 3 ] , :integer ) true iex&gt; DoIt.Helper . validate_list_type ( [ 0 , 1 , 2.1 , 3 ] , :integer ) false iex&gt; DoIt.Helper . validate_list_type ( [ 0.1 , 1.1 , 2.1 , 3.1 ] , :float ) true iex&gt; DoIt.Helper . validate_list_type ( [ 0.1 , 1.1 , 2 , 3.1 ] , :float ) false iex&gt; DoIt.Helper . validate_list_type ( [ &quot;warn&quot; , &quot;error&quot; , &quot;info&quot; , &quot;debug&quot; ] , :string ) true iex&gt; DoIt.Helper . validate_list_type ( [ &quot;warn&quot; , &quot;error&quot; , &quot;info&quot; , 0 ] , :string ) false iex&gt; DoIt.Helper . validate_list_type ( [ &quot;warn&quot; , &quot;error&quot; , &quot;info&quot; , &quot;debug&quot; ] , :unknown ) false","ref":"DoIt.Helper.html#validate_list_type/2","title":"DoIt.Helper.validate_list_type/2","type":"function"},{"doc":"This module parse and validate options.","ref":"DoIt.Option.html","title":"DoIt.Option","type":"module"},{"doc":"","ref":"DoIt.Option.html#default/2","title":"DoIt.Option.default/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#default_filter/1","title":"DoIt.Option.default_filter/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#default_map/2","title":"DoIt.Option.default_map/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#group/1","title":"DoIt.Option.group/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#parse_input/2","title":"DoIt.Option.parse_input/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition/1","title":"DoIt.Option.validate_definition/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_alias/1","title":"DoIt.Option.validate_definition_alias/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_allowed_values/1","title":"DoIt.Option.validate_definition_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_default/1","title":"DoIt.Option.validate_definition_default/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_description/1","title":"DoIt.Option.validate_definition_description/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_keep/1","title":"DoIt.Option.validate_definition_keep/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_name/1","title":"DoIt.Option.validate_definition_name/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_definition_type/1","title":"DoIt.Option.validate_definition_type/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input/2","title":"DoIt.Option.validate_input/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_allowed_values/1","title":"DoIt.Option.validate_input_allowed_values/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_allowed_values/2","title":"DoIt.Option.validate_input_allowed_values/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_value/1","title":"DoIt.Option.validate_input_value/1","type":"function"},{"doc":"","ref":"DoIt.Option.html#validate_input_value/2","title":"DoIt.Option.validate_input_value/2","type":"function"},{"doc":"","ref":"DoIt.Option.html#t:t/0","title":"DoIt.Option.t/0","type":"type"},{"doc":"This module formats command help outputs.","ref":"DoIt.Output.html","title":"DoIt.Output","type":"module"},{"doc":"It returns the allowed values from the given DoIt.Argument . Examples iex&gt; DoIt.Output . format_argument_allowed_values ( % DoIt.Argument { name : :op , type : :string , description : &quot;Operation&quot; , allowed_values : [ &quot;+&quot; , &quot;-&quot; , &quot;*&quot; , &quot;/&quot; ] } ) &quot; (Allowed Values: \\&quot; + \\&quot; , \\&quot; - \\&quot; , \\&quot; * \\&quot; , \\&quot; / \\&quot; )&quot; iex&gt; DoIt.Output . format_argument_allowed_values ( % DoIt.Argument { name : :verbose , type : :boolean , description : &quot;Makes the command verbose&quot; } ) &quot;&quot; iex&gt; DoIt.Output . format_argument_allowed_values ( % DoIt.Argument { name : :number , type : :integer , description : &quot;Numerical digit&quot; , allowed_values : [ 0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ] } ) &quot; (Allowed Values: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9)&quot;","ref":"DoIt.Output.html#format_argument_allowed_values/1","title":"DoIt.Output.format_argument_allowed_values/1","type":"function"},{"doc":"It returns the description from DoIt.Argument . Example iex&gt; DoIt.Output . format_argument_description ( % DoIt.Argument { name : :verbose , type : :boolean , description : &quot;Makes the command verbose&quot; } ) &quot;Makes the command verbose&quot;","ref":"DoIt.Output.html#format_argument_description/1","title":"DoIt.Output.format_argument_description/1","type":"function"},{"doc":"It formats the given DoIt.Argument name attribute with spaces on the right, accordingly with the align parameter. Examples iex&gt; DoIt.Output . format_argument_name ( % DoIt.Argument { name : :verbose , type : :boolean , description : &quot;Makes the command verbose&quot; } , 15 ) &quot;verbose &quot;","ref":"DoIt.Output.html#format_argument_name/2","title":"DoIt.Output.format_argument_name/2","type":"function"},{"doc":"It formats the given DoIt.Option alias attribute. Examples iex&gt; DoIt.Output . format_option_alias ( % DoIt.Option { name : :help , type : :boolean , description : &quot;Shows the help command&quot; , alias : nil } ) &quot; &quot; iex&gt; DoIt.Output . format_option_alias ( % DoIt.Option { name : :help , type : :boolean , description : &quot;Shows the help command&quot; , alias : :h } ) &quot;-h,&quot;","ref":"DoIt.Output.html#format_option_alias/1","title":"DoIt.Output.format_option_alias/1","type":"function"},{"doc":"It returns the allowed values from the given DoIt.Option . Examples iex&gt; DoIt.Output . format_option_allowed_values ( % DoIt.Option { name : :op , type : :string , description : &quot;Operation&quot; , allowed_values : [ &quot;+&quot; , &quot;-&quot; , &quot;*&quot; , &quot;/&quot; ] } ) &quot; (Allowed Values: \\&quot; + \\&quot; , \\&quot; - \\&quot; , \\&quot; * \\&quot; , \\&quot; / \\&quot; )&quot; iex&gt; DoIt.Output . format_option_allowed_values ( % DoIt.Option { name : :verbose , type : :boolean , description : &quot;Makes the command verbose&quot; } ) &quot;&quot; iex&gt; DoIt.Output . format_option_allowed_values ( % DoIt.Option { name : :number , type : :integer , description : &quot;Numerical digit&quot; , allowed_values : [ 0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ] } ) &quot; (Allowed Values: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9)&quot;","ref":"DoIt.Output.html#format_option_allowed_values/1","title":"DoIt.Output.format_option_allowed_values/1","type":"function"},{"doc":"It formats the given DoIt.Option default attribute. Examples iex&gt; DoIt.Output . format_option_default ( % DoIt.Option { name : :log_level , type : :string , description : &quot;Set the logging level&quot; , alias : nil , default : &quot;warn&quot; } ) &quot; (Default: \\&quot; warn \\&quot; )&quot; iex&gt; DoIt.Output . format_option_default ( % DoIt.Option { name : :skip_lines , type : :integer , description : &quot;Lines to skip&quot; , alias : nil , default : 10 } ) &quot; (Default: 10)&quot; iex&gt; DoIt.Output . format_option_default ( % DoIt.Option { name : :help , type : :boolean , description : &quot;Shows the help command&quot; , alias : nil } ) &quot;&quot;","ref":"DoIt.Output.html#format_option_default/1","title":"DoIt.Output.format_option_default/1","type":"function"},{"doc":"It returns the description from DoIt.Option . Examples iex&gt; DoIt.Output . format_option_description ( % DoIt.Option { name : :help , type : :boolean , description : &quot;Shows the help command&quot; , alias : nil } ) &quot;Shows the help command&quot;","ref":"DoIt.Output.html#format_option_description/1","title":"DoIt.Output.format_option_description/1","type":"function"},{"doc":"It formats the given DoIt.Option name attribute with spaces on the right, accordingly with the align parameter. Examples iex&gt; DoIt.Output . format_option_name ( % DoIt.Option { name : :help , type : :boolean , description : &quot;Shows the help command&quot; , alias : nil } , 10 ) &quot;--help &quot; iex&gt; DoIt.Output . format_option_name ( % DoIt.Option { name : :log_level , type : :string , description : &quot;Set the logging level&quot; , alias : nil } , 12 ) &quot;--log-level &quot;","ref":"DoIt.Output.html#format_option_name/2","title":"DoIt.Output.format_option_name/2","type":"function"},{"doc":"It gets the length of the longer name attribute. Examples iex&gt; DoIt.Output . longer_name ( [ %{ name : &quot;great&quot; } , %{ name : &quot;greatest&quot; } ] ) 8 iex&gt; DoIt.Output . longer_name ( [ %{ name : &quot;Elixir&quot; } , %{ name : &quot;Erlang&quot; } , %{ name : &quot;DoIt&quot; } , %{ name : &quot;OTP&quot; } ] ) 6","ref":"DoIt.Output.html#longer_name/1","title":"DoIt.Output.longer_name/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_errors/1","title":"DoIt.Output.print_errors/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_help/1","title":"DoIt.Output.print_help/1","type":"function"},{"doc":"","ref":"DoIt.Output.html#print_invalid_options/2","title":"DoIt.Output.print_invalid_options/2","type":"function"},{"doc":"Initializes DoIt persistent configuration. Examples $ mix do_it.init.config","ref":"Mix.Tasks.DoIt.Init.Config.html","title":"Mix.Tasks.DoIt.Init.Config","type":"task"},{"doc":"It shows a problem with an argument definition.","ref":"DoIt.ArgumentDefinitionError.html","title":"DoIt.ArgumentDefinitionError","type":"exception"},{"doc":"It shows a problem with a command definition.","ref":"DoIt.CommandDefinitionError.html","title":"DoIt.CommandDefinitionError","type":"exception"},{"doc":"It shows a problem with the initialization of the persistent configuration.","ref":"DoIt.InitConfigError.html","title":"DoIt.InitConfigError","type":"exception"},{"doc":"It shows a problem with the main command definition.","ref":"DoIt.MainCommandDefinitionError.html","title":"DoIt.MainCommandDefinitionError","type":"exception"},{"doc":"It shows a problem with an option definition.","ref":"DoIt.OptionDefinitionError.html","title":"DoIt.OptionDefinitionError","type":"exception"},{"doc":"Do It Elixir Command Line Interface Framework. A framework that helps to develop command line tools with Elixir.","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding do_it to your list of dependencies in mix.exs : def deps do [ { :do_it , &quot;~&gt; 0.4.0&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Do It have two main components: DoIt.Command - represents a single command. DoIt.MainCommand - find all defined commands in project and generate all functions to match all commands in a single module, must be used as main_module in escript definition. The commands version and help are automatic generated for the client. The version number is obtained from mix.exs or option version in MainCommand . So, if you have a client named cli , you can type cli version and cli help to get the version number and the list of commands respectively from the client. Command We can define a new command as follows: defmodule Hello do use DoIt.Command , description : &quot;Useless hello command&quot; argument ( :message , :string , &quot;Say hello to...&quot; ) option ( :template , :string , &quot;Hello message template&quot; , alias : :t , default : &quot;Hello &lt;%= @message %&gt;!!!&quot; ) def run ( %{ message : message } , %{ template : template } , _ ) do IO . puts EEx . eval_string ( template , assigns : [ message : message ] ) end end A help option is automatically added to the command to describe its usage. $ ./cli hello --help Usage: cli hello [OPTIONS] &lt;message&gt; Useless hello command Arguments: message Hello nice message Options: --help Print this help -t, --template Hello message template (Default: &quot;Hello &lt;%= @message %&gt;!!!&quot;) Use DoIt.Command and provide a required description , the command name is the module name, you can override that name using the name option. defmodule Hello do use DoIt.Command , name : &quot;olleh&quot; , description : &quot;Useless hello command&quot; ... end MainCommand It's the entrypoint of your CLI, it generates functions matching all defined commands in the project, delegating the call to the matched command. A MainCommand could be defined as follows: defmodule Cli do use DoIt.MainCommand , description : &quot;My useless CLI&quot; end","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"There are two ways to generate the binaries. escript burrito-elixir escript To generate an application using the escript, you have to add a :escript key with the :main_module option to your project properties in your mix.exs file. The :main_module is the module that you defined as DoIt.MainCommand . ... def project do [ app : :hello_world , version : &quot;0.1.0&quot; , elixir : &quot;~&gt; 1.14&quot; , start_permanent : Mix . env ( ) == :prod , deps : deps ( ) , escript : [ main_module : Cli ] ] end ... Build the binary running the mix task bellow. $ mix escript.build ==&gt; do_it Compiling 4 files (.ex) Generated do_it app ==&gt; hello_world Compiling 1 file (.ex) Generated escript hello_world with MIX_ENV=dev A binary with the application name will be generated in the project root. $ ./hello_world help ─╯ Usage: hello_world COMMAND My useless CLI Commands: say Useless hello command burrito-elixir Experimental See the elixir-burrito readme about some limitations and other configurations. To configure the application to use the burrito-elixir you have to add the burrito-elixir dependency in your project, add the :mod property in the application function, and the :releases key with the releases configuration to your project properties in you mix.exs file. The :mod property value is the module that you defined as DoIt.MainCommand . defmodule CoinGeckoCli.MixProject do use Mix.Project def project do [ app : :coin_gecko_cli , version : &quot;0.1.0&quot; , elixir : &quot;~&gt; 1.14&quot; , start_permanent : Mix . env ( ) == :prod , deps : deps ( ) , releases : releases ( ) ] end # Run &quot;mix help compile.app&quot; to learn about applications. def application do [ extra_applications : [ :logger ] , mod : { CoinGeckoCli , [ ] } ] end # Run &quot;mix help deps&quot; to learn about dependencies. defp deps do [ { :tesla , &quot;~&gt; 1.7&quot; } , { :jason , &quot;~&gt; 1.4&quot; } , { :do_it , &quot;~&gt; 0.4&quot; } , { :burrito , github : &quot;burrito-elixir/burrito&quot; } , { :tableize , &quot;~&gt; 0.1.0&quot; } ] end def releases do [ coin_gecko_cli : [ steps : [ :assemble , &amp; Burrito . wrap / 1 ] , burrito : [ targets : [ macos : [ os : :darwin , cpu : :x86_64 ] , linux : [ os : :linux , cpu : :x86_64 ] , windows : [ os : :windows , cpu : :x86_64 ] ] , ] ] ] end end Generate the binaries using the mix task bellow, a binary of each target will be generated in the burrito_out folder of your root application. $ MIX_ENV=prod mix release ... ... ... $ cd burrito_out $ ls -c1 ─╯ coin_gecko_cli_linux coin_gecko_cli_macos coin_gecko_cli_windows $ ./coin_gecko_cli_linux help ─╯ Usage: coin_gecko_cli COMMAND CoinGecko CLI Commands: list List assets","ref":"readme.html#package","title":"README - Package","type":"extras"},{"doc":"DoIt is released under the Apache License 2.0 - see the LICENSE file.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Copyright 2021 Rodrigo Zampieri Castilho &lt;rodrigo.zampieri@gmail.com&gt; Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]